<?php

defined('BASEPATH') OR exit('No direct script access allowed');
class Cart extends CI_Controller {
	var $postdata;
	var $user_agent;
	var $request_url;
	var $method_name;
	public function  __construct()
	{
		parent:: __construct();
		error_reporting(E_ALL ^ E_NOTICE);
		$this->load->model(array('registerlogin_model','sms_model','notification_model','emailtemplate_model','appmodel'));
		$this->user_agent 		= 	$_SERVER['HTTP_USER_AGENT'];
		$this->request_url 		= 	$_SERVER['REDIRECT_URL'];
		$this->method_name 		= 	$_SERVER['REDIRECT_QUERY_STRING'];
		$this->load->library('generatelogs',array('type'=>'common'));
		$this->load->library('cart');
	}

	/* * *********************************************************************
	 * * Function name 	: addToCart
	 * * Developed By 	: Afsar ALi
	 * * Purpose  		: This function used for add item to cart
	 * * Date 			: 11 APRIL 2022
	 * * **********************************************************************/
	public function addToCart()
	{
		//echo "working";die();
		$apiHeaderData 		=	getApiHeaderData();
		$this->lang->load('users',$apiHeaderData['Apilanguage']);
		$this->lang->load('usersform',$apiHeaderData['Apilanguage']);
		$this->generatelogs->putLog('APP',logOutPut($_POST));
		$result 							= 	array();
		$returnData 						= 	array();
		if(requestAuthenticate(APIKEY)):
			if($this->input->post('user_id') == ''):
				echo outPut(0,lang('user_id_empty'),$result);
			elseif ($this->input->post('product_id') == '') :
				echo outPut(0,lang('product_id_empty'),$result);
			else:
				$insert_data 	= array(
					'user_id'		=>	$this->input->post('user_id'),
					'product_id'	=>	$this->input->post('product_id'),
					'created_at	'	=>	date('Y-m-d H:i'),
					'created_ip	'	=>	$this->input->ip_address(),
					);
				$wherecon 		=	[ 'user_id' 	=> $insert_data['user_id'],
									  'product_id'	=> $insert_data['product_id'] ];
				$check 	= $this->appmodel->select_all('api_cart', $wherecon);

				if(!empty($check)):
					echo outPut(0,lang('already_exists'),$result);
				else:
					$insert_id 		= 	$this->appmodel->insert_one('api_cart', $insert_data);
					if (!empty($insert_id)):
				    $result = $insert_data;
				    	echo outPut(1,lang('data_added'),$result);
					else:
					    echo outPut(0,lang('data_not_insert'),$result);
					endif;
				endif;
			endif;
		else:
			echo outPut(0,lang('invalid_api_key'),$result);
		endif;
	}

	/* * *********************************************************************
	 * * Function name 	: getCartList
	 * * Developed By 	: Afsar ALi
	 * * Purpose  		: This function used for get cart Items
	 * * Date 			: 11 APRIL 2022
	 * * **********************************************************************/
	public function getCartItems()
	{
		//echo "working";die();
		$apiHeaderData 		=	getApiHeaderData();
		$this->lang->load('users',$apiHeaderData['Apilanguage']);
		$this->lang->load('usersform',$apiHeaderData['Apilanguage']);
		$this->generatelogs->putLog('APP',logOutPut($_POST));
		$result 							= 	array();
		$returnData 						= 	array();
		if(requestAuthenticate(APIKEY)):
			if($this->input->post('user_id') == ''):
				echo outPut(0,lang('user_id_empty'),$result);
			else:
				$where = [ 'user_id' => $this->input->post('user_id') ];
				$data = $this->appmodel->select_all('api_cart', $where);
				$num = count($data);
				for($i=0; $i < $num; $i++):
					$wherecon = [ 'id' => $data[$i]->product_id ];
					$product[$i] = $this->appmodel->select_one_only('courses', $wherecon);
					$product[$i]->user_id = $this->input->post('user_id');
				endfor;
				if (!empty($product)):
				    $result = $product;
				    echo outPut(1,lang('data_found'),$result);
				else:
				    echo outPut(0,lang('data_not_found'),$result);
				endif;
			endif;
		else:
			echo outPut(0,lang('invalid_api_key'),$result);
		endif;
	}


	/* * *********************************************************************
	 * * Function name 	: removeCartItems
	 * * Developed By 	: Afsar ALi
	 * * Purpose  		: This function used for remove item from cart
	 * * Date 			: 11 APRIL 2022
	 * * **********************************************************************/
	public function removeCartItems()
	{
		$apiHeaderData 		=	getApiHeaderData();
		$this->lang->load('users',$apiHeaderData['Apilanguage']);
		$this->lang->load('usersform',$apiHeaderData['Apilanguage']);
		$this->generatelogs->putLog('APP',logOutPut($_POST));
		$result 							= 	array();
		$returnData 						= 	array();
		if(requestAuthenticate(APIKEY)):
			if($this->input->post('product_id') == ''):
				echo outPut(0,lang('cart_product_id'),$result);
			elseif($this->input->post('user_id') == ''):
				echo outPut(0,lang('user_id_empty'),$result);
			else:
				$where 			=	[ 'user_id' => $this->input->post('user_id'),
									  'product_id' => $this->input->post('product_id') ];
				$isDelete 		= 	$this->appmodel->delete_one('api_cart', $where);
				//echo $isDelete; die();
				if (!empty($isDelete)):
				    $where = [ 'user_id' => $this->input->post('user_id') ];
					$data = $this->appmodel->select_all('api_cart', $where);
					$num = count($data);
					for($i=0; $i < $num; $i++):
						$wherecon = [ 'id' => $data[$i]->product_id ];
						$product[$i] = $this->appmodel->select_one_only('courses', $wherecon);
						$product[$i]->user_id = $this->input->post('user_id');
					endfor;
				    $result = $product;
				    echo outPut(1,lang('data_deleted'),$result);
				else:
				    echo outPut(0,lang('data_not_deleted'),$result);
				endif;
			endif;
		else:
			echo outPut(0,lang('invalid_api_key'),$result);
		endif;
	}

}
