<?php
if(!function_exists('apache_request_headers')) {
	function apache_request_headers() {
		static $arrHttpHeaders;
		if (!$arrHttpHeaders) {
			$arrCasedHeaders = array(
				// HTTP
				'Dasl'             => 'DASL',
				'Dav'              => 'DAV',
				'Etag'             => 'ETag',
				'Mime-Version'     => 'MIME-Version',
				'Slug'             => 'SLUG',
				'Te'               => 'TE',
				'Www-Authenticate' => 'WWW-Authenticate',
				// MIME
				'Content-Md5'      => 'Content-MD5',
				'Content-Id'       => 'Content-ID',
				'Content-Features' => 'Content-features',
			);
			$arrHttpHeaders = array();
			foreach($_SERVER as $strKey => $mixValue) {
				if('HTTP_' !== substr($strKey, 0, 5)) {
					continue;
				}
				$strHeaderKey = strtolower(substr($strKey, 5));
				if(0 < substr_count($strHeaderKey, '_')) {
					$arrHeaderKey = explode('_', $strHeaderKey);
					$arrHeaderKey = array_map('ucfirst', $arrHeaderKey);
					$strHeaderKey = implode('-', $arrHeaderKey);
				}
				else {
					$strHeaderKey = ucfirst($strHeaderKey);
				}
				if(array_key_exists($strHeaderKey, $arrCasedHeaders)) {
					$strHeaderKey = $arrCasedHeaders[$strHeaderKey];
				}
				$arrHttpHeaders[$strHeaderKey] = $mixValue;
			}
			if (isset($arrHttHeaders['Authorization']) && $arrHttHeaders['Authorization']) {
				if (!isset($_SERVER['PHP_AUTH_USER'])) {
					list($_SERVER['PHP_AUTH_USER'], $_SERVER['PHP_AUTH_PW']) = explode(':' , base64_decode(substr($_SERVER['HTTP_AUTHORIZATION'], 6)));
				}
			}
		}
		return $arrHttpHeaders;
	}
}
/*
 * check api header data
 */
if (!function_exists('getApiHeaderData')) { 
	function getApiHeaderData(){ 
		$headerData	=	apache_request_headers();  
        return $headerData;
	} 
} 
/*
 * check apiKey valid or not
 */
if (!function_exists('requestAuthenticate')) { 
	function requestAuthenticate($apiKey=''){ 
		$headerData	=	apache_request_headers();  
        if($headerData['Apidate']):
            $apiKey      =	md5("societyApp".$headerData['Apidate']);
	    endif;
		if($apiKey == $headerData['Apikey']): 
			if($headerData['Apitoken']):
				$where['where']['seller_token']		=	$headerData['Apitoken'];
				$where['where']['login_status']		=	'Login';
				$CI =& get_instance();
				$tokenData = $CI->common_model->getParticularFieldByMultipleCondition(array('login_log_id','seller_id'),'hcap_seller_login_log',$where);
				if($tokenData <> ""):
					//return true;
					$Uwhere['where']['seller_id']	=	$tokenData['seller_id'];
					$customerData = $CI->common_model->getParticularFieldByMultipleCondition(array('seller_id','status'),'hcap_seller',$Uwhere);
					if($customerData <> ""): 	
						if($customerData['status'] == 'A'):		
							return true;
						else:	
							return 'Logout';
						endif;
					else:		
						return 'Logout';
					endif;
				else:		
					return 'Logout';
				endif;
	        else:
	         	return true;
		    endif;
		else:
			return false;
		endif;
	} 
} 

/*
 * json outPut
 */
if (!function_exists('outPut')) {
	function outPut($status=0,$message='',$returnData=array()){
		$data					=	array();
		$result 				= 	array();
		if($status==0){
			$data['success'] 	= 	$status;
			$data['message'] 	= 	$message;
			$data['result'] 	=	(object) $result;
		}else{
			$data['success'] 	= 	$status;
			$data['message'] 	= 	$message;
			$data['result'] 	= 	$returnData;
		}
		header('Content-type: application/json');
		return json_encode($data);
	}
}

/*
 * json outPut
 */
if (!function_exists('logOutPut')) {
	function logOutPut($returnData=array()){
		header('Content-type: application/json');
		return json_encode($returnData);
	}
}	

/*
 * generate session id
 */
if (!function_exists('generateSessionId')) {
	function generateSessionId(){
		$uniqueId = uniqid(rand(),TRUE);
		return md5($uniqueId);
	}
}

if (!function_exists('generateWalletTnxId')) {
	function generateWalletTnxId() {
		$characters = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";	
		$charactersLength = strlen($characters);
		$randomString = '';
		for ($i = 0; $i < 15; $i++) {
			$randomString .= $characters[rand(0, $charactersLength - 1)];
		}
		return 'WALL'.$randomString;
	}
}
if (!function_exists('generateCODTnxId')) {
	function generateCODTnxId() {
		$characters = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";	
		$charactersLength = strlen($characters);
		$randomString = '';
		for ($i = 0; $i < 15; $i++) {
			$randomString .= $characters[rand(0, $charactersLength - 1)];
		}
		return 'COD'.$randomString;
	}
}
if (!function_exists('generateAffiliateId')) {
	function generateAffiliateId() {
		$characters = "123456789ABCDEFGHIJKLMNPQRSTUVWXYZ";	
		$charactersLength = strlen($characters);
		$randomString = '';
		for ($i = 0; $i < 6; $i++) {
			$randomString .= $characters[rand(0, $charactersLength - 1)];
		}
		return 'AP'.$randomString;
	}
}?>