<?php
// make friendly url using any string
if (!function_exists('friendlyURL')) {
	function friendlyURL($inputString){
		$url = strtolower($inputString);
		$patterns = $replacements = array();
		$patterns[0] = '/(&amp;|&)/i';
		$replacements[0] = '-and-';
		$patterns[1] = '/[^a-zA-Z01-9]/i';
		$replacements[1] = '-';
		$patterns[2] = '/(-+)/i';
		$replacements[2] = '-';
		$patterns[3] = '/(-$|^-)/i';
		$replacements[3] = '';
		$url = preg_replace($patterns, $replacements, $url);
	return $url;
	}
}

if (!function_exists('sanitizedNumber')) {
	function replaceSpecialCharInUrl($str)
	{
		$find     =   array("\t","\n"," ");
		$replace  =   array("","","");
		return str_replace($find,$replace,$str);
	}
}

// sanitized number :  function auto remove unwanted character form given value 
if (!function_exists('sanitizedNumber')) {
	function sanitizedNumber($_input) 
	{ 
		return (float) preg_replace('/[^0-9.]*/','',$_input); 
	}
}

// sanitized filename :  function auto remove unwanted character form given file name
if (!function_exists('sanitizedFilename')) {
	function sanitizedFilename($filename){
		$sanitized = preg_replace('/[^a-zA-Z0-9-_\.]/','', $filename);
		return $sanitized;
	}
}

// check, is file exist in folder or not
if (!function_exists('fileExist')) {
	function fileExist($source='', $file='', $defalut=''){
		if(!$file) return base_url().$source.$defalut;
			
		if(file_exists(FCPATH.$source.$file)):
			return base_url().$source.$file;
		else:
			return base_url().$source.$defalut;
		endif;
	}
}

// check, is file exist in folder or not
if (!function_exists('checkFileExist')) {
	function checkFileExist($source=''){
		if(file_exists(FCPATH.$source)):
			return base_url().$source;
		else:
			return false;
		endif;
	}
}

if (!function_exists('myExplode')) {
	function myExplode($string){
		if($string):
			$array = explode(",",$string);
			return $array;
		else:
			return '';
		endif;
	}
}

/*
 * Show correct image
 */
if (!function_exists('correctImage')) {
	function correctImage($imageurl, $type = '') {
		if($type=='original'):
			$imageurl = str_replace('/thumb','',$imageurl);
		elseif($type):
			$imageurl = str_replace('thumb',$type,$imageurl);
		endif;
		return trim($imageurl);
	}
}

/*
 * Encription
 */
if (!function_exists('manojEncript')) {
	function manojEncript($text) {
		$text	=	('MANOJ').$text.('KUMAR');
		return	base64_encode($text);
	}
}

/*
 * Decription
 */
if (!function_exists('manojDecript')) {
	function manojDecript($text) {
		$text	=	base64_decode($text);
		$text	=	str_replace(('MANOJ'),'',$text);
		$text	=	str_replace(('KUMAR'),'',$text);
		return $text;
	}
}

/*
 * Word Limiter
 */
define("STRING_DELIMITER", " ");
if (!function_exists('wordLimiter')){
	function wordLimiter($str, $limit = 10){
		$str = strip_tags($str); 
		if (stripos($str, STRING_DELIMITER)){
			$ex_str = explode(STRING_DELIMITER, $str);
			if (count($ex_str) > $limit){
				for ($i = 0; $i < $limit; $i++){
					$str_s.=$ex_str[$i].'&nbsp;';
				}
				return $str_s.'...';
			}else{
				return $str;
			}
		}else{
			return $str;
		}
	}
}

if (!function_exists('currentDateTime')) {
	function currentDateTime() {
		return time();
	}
}

if (!function_exists('currentStartDateTime')) {
	function currentStartDateTime() {
		return date('Y-m-d');
	}
}

if (!function_exists('showDate')) {
	function showDate($time='') {
		if($time):
			return date("d-m-Y",$time);
		else:
			return false;
		endif;
	}
}

if (!function_exists('showTime')) {
	function showTime($time='') {
		if($time):
			return date("H:i:s",$time);
		else:
			return false;
		endif;
	}
}

if (!function_exists('showDateTime')) {
	function showDateTime($time='') {
		if($time):
			return date("d-m-Y H:i:s",$time);
		else:
			return false;
		endif;
	}
}

/*
 * Show correct image
 */
if (!function_exists('getCamelCasePosatalData')) {
	function getCamelCasePosatalData($data = '') {
		$repPre 	=	array('+');
		$repPos 	=	array(' ');
		if($data):
			$data 	=	ucwords(strtolower(str_replace($repPre,$repPos,trim($data))));
		endif;
		return trim($data);
	}
}


if (!function_exists('currentIp')) {
	function currentIp() {
		return $_SERVER['REMOTE_ADDR']=='::1'?'192.168.1.100':$_SERVER['REMOTE_ADDR'];
	}
}

if (!function_exists('generateRandomString')) {
	function generateRandomString($length = 10, $mode="n",$type='') {
		if($type == 'otp' && SMS_SEND_STATUS == 'NO'):
			return '4321';
		elseif($type == 'password' && SMS_SEND_STATUS == 'NO'):
			return 'cashmyproperty@21062021';
		else:
			$characters = "";
			if(strpos($mode,"s")!==false){$characters.="abcdefghjklmnpqrstuvwxyz";}
			if(strpos($mode,"l")!==false){$characters.="ABCDEFGHJKLMNPQRSTUVWXYZ";}
			if(strpos($mode,"n")!==false){$characters.="0123456789";}
			$charactersLength = strlen($characters);
			$randomString = '';
			for ($i = 0; $i < $length; $i++) {
				$randomString .= $characters[rand(0, $charactersLength - 1)];
			} 
			/*
			if(strlen($randomString) == $length):
				return $randomString;
			else:
				return generateRandomString($length,$mode,$type);
			endif;
			*/
			/*
			$remaingNumberOfDigits = $length - strlen($randomString);
			if($remaingNumberOfDigits > 0):
				for($remaingDigitsCounter = 0; $remaingDigitsCounter < $remaingNumberOfDigits; $remaingDigitsCounter++):
					$randomString = $randomString .rand ( 0 , 9);
				endfor;
			endif;
			return $randomString;
			*/
			return rand(100000,999999);
		endif;
	}
}

if (!function_exists('generateReferralCode')) {
	function generateReferralCode() {
		return 'MK'.rand(100000,999999);
	}
}

if (!function_exists('displayPrice')) {
	function displayPrice($price) {
		if(checkFloat($price)):
			return "Rs. ".number_format($price, 2, '.', '');
		else:
			return "Rs. ".number_format($price);
		endif;
	}
}

if (!function_exists('numberFormat')) {
	function numberFormat($price) {
		if(checkFloat($price)):
			return number_format($price, 2, '.', '');
		else:
			return number_format($price, 2, '.', '');
		endif;
	}
}

if (!function_exists('displayPercent')) {
	function displayPercent($price) {
		if(checkFloat($price)):
			return number_format($price, 2, '.', '').'%';
		else:
			return number_format($price).'%';
		endif;
	}
}

if (!function_exists('calculatePercent')) {
	function calculatePercent($prevpr,$curpr) {
		$val = $prevpr-$curpr;
		if($val<=0):
			$amountper = 0;
		else:
			$amountper = (($prevpr-$curpr)/($prevpr))*100;
		endif;
		if($amountper==100):
			$amountper = 0;
		endif;
		if(checkFloat($amountper)):
			return number_format($amountper,2, '.', '');
		else:
			return number_format($amountper);
		endif;
	}
}

if (!function_exists('checkFloat')) {
	function checkFloat($s_value) {
		$regex = '/^\s*[+\-]?(?:\d+(?:\.\d*)?|\.\d+)\s*$/';
		return preg_match($regex, $s_value);
	}
}

/*
 * Get session data
 */
if (!function_exists('sessionData')) {
	function sessionData($text) {
		$CIOBJ = & get_instance();
		return	$CIOBJ->session->userdata($text);
	}
}

/*
 * Get correct link
 */
if (!function_exists('correctLink')) {
	function correctLink($text='',$link='') {
		return	sessionData($text)?sessionData($text):$link;
	}
}

/*
 * Get full url
 */
 if (!function_exists('currentFullUrl')) {
	function currentFullUrl()
	{
		$CI =& get_instance();
		$url = $CI->config->site_url($CI->uri->uri_string());
		return $_SERVER['QUERY_STRING'] ? $url.'?'.$_SERVER['QUERY_STRING'] : $url;
	}
}

if (!function_exists('generateUniqueId')) {
	function generateUniqueId($currentId = 1) {
		$newId		=	10000000000000+$currentId;
		return $newId;
	}
}

if (!function_exists('generateToken')) {
	function generateToken() {
		$characters = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";	
		$charactersLength = strlen($characters);
		$randomString = '';
		for ($i = 0; $i < 32; $i++) {
			$randomString .= $characters[rand(0, $charactersLength - 1)];
		}
		return $randomString;
	}
}

/*
 * convert time to date
 */
if (!function_exists('convertTimeToDate')) {
	function convertTimeToDate($time='') {
		return $time?date('d-m-Y',$time):'';
	}
}

/*
 * convert date to time
 */
if (!function_exists('convertDateToTime')) {
	function convertDateToTime($date='') {
		return $date?strtotime($date):'';
	}
}

/*
 * Show Current MK Time
 */
if (!function_exists('getCurrentMKTime')) {
	function getCurrentMKTime()
	{  
		return mktime(date("H"), date("i"), date("s"), date("m"), date("d"), date("Y"));;
	}
}

/*
 * Show Current Time
 */
if (!function_exists('getCurrentTime')) {
	function getCurrentTime()
	{  
		return date("H:i:s");
	}
}

/*
* Get diff Bet Two Date
*/
if (!function_exists('diffBetTwoDate')) {
	function diffBetTwoDate($firstDate='',$secondDate=''){
		$daysLeft 		= 	abs($firstDate - $secondDate);
		$days 			= 	$daysLeft/(60*60*24);
		return $days;
	}
}

if (!function_exists('diffBetTwoStandardDate')) {
	function diffBetTwoStandardDate($firstDate='',$secondDate=''){
		$daysLeft 		= 	abs($secondDate - $firstDate);
		$days 			= 	$daysLeft/(60*60*24);
		return $days;
	}
}

/*
* Get day range list between two date
*/
if (!function_exists('dateRangeBetweenTwoDate')) {
	function dateRangeBetweenTwoDate($first='',$last='',$step='+1 day',$outputFormat='d-m-Y') {
		$dates		= 	array();
		$current 	= 	$first;
		$last 		= 	$last;
		while($current <= $last):
			$dates[] 	= 	date($outputFormat,$current);
			$current 	= 	strtotime($step,$current);
		endwhile;
		return $dates;
	}
}

/*
* Get day range list between two date
*/
if (!function_exists('hourRangeBetweenTwoDateTime')) {
	function hourRangeBetweenTwoDateTime($first='',$last='',$step='1',$stepType=' hour') {
		$step 		=	'+'.$step.' '.$stepType;
		$dates		= 	array();
		$current 	= 	$first;//strtotime($first);
		$last 		= 	$last;//strtotime($last);
		while($current <= $last):
			$dates[] 	= 	$current;
			$current 	= 	strtotime($step,$current);
		endwhile;
		return $dates;
	}
}


if (!function_exists('array_sort_by_column')) {
	function array_sort_by_column(&$arr, $col, $dir = SORT_ASC) {
	    $sort_col = array();
	    foreach ($arr as $key=> $row) {
	        $sort_col[$key] = $row[$col];
	    }
	    array_multisort($sort_col, $dir, $arr);
	}
}

/*
 * sanitized Field Name
 */
if (!function_exists('sanitizedFieldName')) {
	function sanitizedFieldName($filename){
		$sanitized = preg_replace('/[^a-zA-Z0-9-_\.]/','', $filename);
		return $sanitized;
	}
}

/*
 * show correct files
 */
if (!function_exists('showCorrectFile')) {
	function showCorrectFile($fileLink) {
		if($fileLink):
			$fileLinkArray 	=	explode('assets/',$fileLink);
			$fileLink 		=	fileBaseUrl.'assets/'.$fileLinkArray[1];
			//echo $fileBaseUrl.'--'.$fileFCPATH; die;
		endif;
		return $fileLink;
	}
}