<?php
defined('BASEPATH') OR exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
$curUrl						=	explode('/',$_SERVER['REQUEST_URI']);
/////////////   Localhost 		/////////////////
if($_SERVER['SERVER_NAME']=='localhost'):
	$firstSlug				=	isset($curUrl[3])?$curUrl[3]:'';
	$secondSlug				=	isset($curUrl[4])?$curUrl[4]:'';

/////////////  SERVER 		/////////////////
else:
	$firstSlug				=	isset($curUrl[3])?$curUrl[3]:'';
	$secondSlug				=	isset($curUrl[4])?$curUrl[4]:'';
endif;

switch($secondSlug):
	case 'users':	######### 	USERS SECTION 												##########################
		$route['users/putSignupForm'] 													= 	'account/putSignupForm';
		$route['users/putSignupVerificationForm'] 										= 	'account/putSignupVerificationForm';
		$route['users/setLogout'] 														= 	'account/setLogout';
		$route['users/resendOTP'] 														= 	'account/resendOTP';

	break;

	case 'cms':	######### 	CMS SECTION
		$route['cms/getBlogsData'] 				= 	'cms/getBlogsData';
		$route['cms/getTestimonialData'] 		= 	'cms/getTestimonialData';
		$route['cms/getHomepageData'] 			= 	'cms/getHomepageData';
		$route['cms/getMeditationsData'] 		= 	'cms/getMeditationsData';
		$route['cms/contactUs'] 				= 	'cms/contactUs';
		$route['cms/getSessionData'] 			= 	'cms/getSessionData';
		$route['cms/getSessionDetailsData'] 	= 	'cms/getSessionDetailsData';
		$route['cms/getCoursesData'] 			= 	'cms/getCoursesData';
		$route['cms/getmodalitiesData'] 		= 	'cms/getmodalitiesData';
	$route['cms/getEvolvingSparksDetailsData'] 		= 	'cms/getEvolvingSparksDetailsData';
	break;

case 'membership':	######### 	MEMBERSHIP SECTION
		$route['membership/getMembershipData'] 		= 	'membership/getMembershipData';
		$route['membership/getMembershipDetailsData'] 		= 	'membership/getMembershipDetailsData';

	break;

	case 'login':	######### 	CMS SECTION

		$route['login/userSignin'] 				= 	'login/userSignin';
		$route['login/createUser'] 				= 	'login/createUser';
		$route['login/completeYourProfile'] 	= 	'login/completeYourProfile';

	break;

	case 'appointments':	######### 	APPOINTMENT SECTION

		$route['appointments/bookAppointment'] 				= 	'appointments/bookAppointment';

	break;

	case 'home':	######### 	HOME SECTION 	##########################

		$route['home/getHomepageData'] 													= 	'home/getHomepageData';
	break;
	case 'profile':	######### 	PROFILE SECTION
		$route['profile/editProfile'] 				= 	'profile/editProfile';
	break;

	case 'orders':	######### 	ORDER SECTION
		$route['orders/proceedtopay'] 					= 	'order/proceedtopay';
		$route['orders/paymentsuccess'] 			= 	'order/paymentsuccess';
	break;


endswitch;

$route['default_controller'] 															= 	'welcome/index';
$route['404_override'] 																	= 	'';
$route['translate_uri_dashes'] 															= 	FALSE;
//echo '<pre>'; print_r($route); die;
