<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Appointments extends CI_Controller {
	var $postdata;
	var $user_agent;
	var $request_url;
	var $method_name;

	public function  __construct()
	{
		parent:: __construct();
		error_reporting(E_ALL ^ E_NOTICE);
		$this->load->model(array('registerlogin_model','sms_model','notification_model','emailtemplate_model'));
		$this->lang->load('users','english');
        $this->lang->load('usersform','english');
		$this->user_agent 		= 	$_SERVER['HTTP_USER_AGENT'];
		$this->request_url 		= 	$_SERVER['REDIRECT_URL'];
		$this->method_name 		= 	$_SERVER['REDIRECT_QUERY_STRING'];

		$this->load->library('generatelogs',array('type'=>'common'));
	}

	/* * *********************************************************************
	 * * Function name : bookAppointment
	 * * Developed By : Afsar Ali
	 * * Purpose  : This function used for Book Appointment
	 * * Date : 22 MARCH 2022
	 * * **********************************************************************/
	public function bookAppointment()
	{
		$apiHeaderData 		=	getApiHeaderData();
		$this->lang->load('users',$apiHeaderData['Apilanguage']);
		$this->lang->load('usersform',$apiHeaderData['Apilanguage']);
		$this->generatelogs->putLog('APP',logOutPut($_POST));
		$result 							= 	array();
		$returnData 						= 	array();
		if(requestAuthenticate(APIKEY)):
			if($this->input->post('type') == ''):
				echo outPut(0,lang('type_empty'),$result);
			elseif($this->input->post('name') == ''):
				echo outPut(0,lang('name_empty'),$result);
			elseif($this->input->post('email') == ''):
				echo outPut(0,lang('email_empty'),$result);
			elseif($this->input->post('mobile') == ''):
				echo outPut(0,lang('mobile_empty'),$result);
			elseif($this->input->post('date') == ''):
				echo outPut(0,lang('users_schedule_date'),$result);
			elseif($this->input->post('time') == ''):
				echo outPut(0,lang('users_schedule_time'),$result);
			elseif($this->input->post('message') == ''):
				echo outPut(0,lang('msg_empty'),$result);
			else:

				$insert_data 		=	array(
					'type'			=>	$this->input->post('type'),
					'name'			=>	$this->input->post('name'),
					'email'			=>	$this->input->post('email'),
					'mobile'		=>	$this->input->post('mobile'),
					'date'			=>	$this->input->post('date'),
					'time'			=>	$this->input->post('time'),
					'message'		=>	$this->input->post('message'),
					'created_at'	=>	date('Y-m-d H:i:s')
				);
				$isBlock = $this->appmodel->checkAppointmentSlot($this->input->post('date'), $this->input->post('time'));
				if($isBlock == 'Available'):

					$tbl 			=	'api_appointments';
					$insert_id 		= 	$this->appmodel->insert_one($tbl, $insert_data);
					if (!empty($insert_id)) :
	      				// Mail Start Here
						$to 		= 'rajkumarkamdar@thedivinesparks.com';
				        $subject 	= " Appointment Request from ".$this->input->post('name')."";
				        $message 	= "
				        <html>
				        <head>
				        <title> The Divine Sparks | Appointment Request </title>
				        </head>
				        <body>
				        <p> Appointment request from ".$this->input->post('name')." :<br>
				        ".$this->input->post('message')."
				        </p>
				        </body>
				        </html>
				        ";
				        // Always set content-type when sending HTML email
				        $headers 	= "MIME-Version: 1.0" . "\r\n";
				        $headers 	.= "Content-type:text/html;charset=UTF-8" . "\r\n";
				        // More headers
	      				$headers 	.= 'From: <info@algosoft.co>' . "\r\n";
				        //$headers 	.= 'From: <'.$this->input->post('email').'>' . "\r\n";
				        //$headers .= 'Cc: info@algosoft.co' . "\r\n";
				        //mail($to, $subject, $message, $headers);
						// Mail End Here
						echo outPut(1,lang('data_added'),$insert_data);
					else: 
						echo outPut(0,lang('data_not_insert'),$insert_data);
					endif;
				else:
					echo outPut(0,lang('no_slot_availaible'),$insert_data);
				endif;
			endif;
		else:
			echo outPut(0,lang('invalid_api_key'),$result);
		endif;
	}


}
