<?php
defined('BASEPATH') OR exit('No direct script access allowed');

/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	https://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There are three reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router which controller/method to use if those
| provided in the URL cannot be matched to a valid route.
|
|	$route['translate_uri_dashes'] = FALSE;
|
| This is not exactly a route, but allows you to automatically route
| controller and method names that contain dashes. '-' isn't a valid
| class or method name character, so it requires translation.
| When you set this option to TRUE, it will replace ALL dashes in the
| controller and method URI segments.
|
| Examples:	my-controller/index	-> my_controller/index
|		my-controller/my-method	-> my_controller/my_method
*/
if(strpos($_SERVER['REQUEST_URI'],'api/')):
	###############################################################################################
	#################################		API FOR APP		  #####################################
	###############################################################################################
	///////////////////////////				USER			///////////////////////////////////////	
	$route['api/getStateList'] 								= 	'api/lowers/getStateList';	
	$route['api/getCityList'] 								= 	'api/lowers/getCityList';	
	$route['api/getLowerTypesList'] 						= 	'api/lowers/getLowerTypesList';
	$route['api/getLowerList'] 								= 	'api/lowers/getLowerList';	
	$route['api/getILTalkList'] 							= 	'api/iltalks/getILTalkList';	
	$route['api/getWebnarList'] 							= 	'api/webinar/getWebnarList';	
	$route['api/getWebnarDetailsData'] 						= 	'api/webinar/getWebnarDetailsData';	
	$route['api/getMootCourtList'] 							= 	'api/mootcourt/getMootCourtList';
	$route['api/getMootCourtDetailsData'] 					= 	'api/mootcourt/getMootCourtDetailsData';	
	
else:
	###############################################################################################
	#################################		WEBSITE ADMIN	  #####################################
	###############################################################################################
	$route['default_controller'] 									= 	'front/Home/index';
	
	
	$route['404_override'] 											= 	'';
	$route['translate_uri_dashes'] 									= 	FALSE;

	$curUrl						=	strpos($_SERVER['REQUEST_URI'],'/?')?explode('/?',$_SERVER['REQUEST_URI']):explode('?',$_SERVER['REQUEST_URI']); 
	$curUrl						=	explode('/',$curUrl[0]); //print_r($curUrl); die;
	if($_SERVER['SERVER_NAME']=='localhost'):	/////////////   Localhost 		/////////////////
		$firstSlug				=	isset($curUrl[2])?$curUrl[2]:'';
		$secondSlug				=	isset($curUrl[3])?$curUrl[3]:'';
		$thirdSlug				=	isset($curUrl[4])?$curUrl[4]:'';
		$fourthlug				=	isset($curUrl[5])?$curUrl[5]:'';
	else: 	/////////////   SERVER		/////////////////	
		$firstSlug				=	isset($curUrl[4])?$curUrl[4]:'';
		$secondSlug				=	isset($curUrl[5])?$curUrl[5]:'';
		$thirdSlug				=	isset($curUrl[6])?$curUrl[6]:'';
		$fourthlug				=	isset($curUrl[7])?$curUrl[7]:'';
	endif;

	if($firstSlug == ''):  
		$route['home'] 											= 	'front/Home/index';
		elseif($firstSlug == ''):  
			$route['course'] 									= 	'front/Home/course';
			elseif($firstSlug == ''):  
				$route['signup'] 									= 	'front/login_user/signup';
	elseif($firstSlug == 'login'):  
		$route['login'] 											= 	'admin/login/index';
		
		
	
			elseif($firstSlug == 'login-verify-otp'):  
		$route['login-verify-otp'] 									= 	'admin/login/loginverifyotp';
	elseif($firstSlug == 'resend-otp'):  
		$route['resend-otp'] 										= 	'admin/login/resendotp';
	elseif($firstSlug == 'forgot-password'):  
		$route['forgot-password'] 									= 	'admin/login/forgotpassword';
	elseif($firstSlug == 'password-recover'):  
		$route['password-recover'] 									= 	'admin/login/passwordrecover';
	elseif($firstSlug == 'logout'):  
		$route['logout'] 											= 	'admin/login/logout';
	elseif($firstSlug == 'maindashboard'):  
	    echo'ttt';die;
		$route['maindashboard'] 									= 	'admin/account/maindashboard';
	elseif($firstSlug == 'dashboard'):  
		$route['dashboard'] 										= 	'admin/account/maindashboard';

		
	elseif($firstSlug == 'profile'):  		
		$route['profile'] 											= 	'admin/account/profile';
	elseif($firstSlug == 'editprofile'):  
		$route['editprofile'] 										= 	'admin/account/editprofile';
		$route['editprofile/(:any)'] 								= 	'admin/account/editprofile/$1';
	elseif($firstSlug == 'change-password'):  
		$route['change-password'] 									= 	'admin/account/changepassword';
		$route['change-password/(:any)'] 							= 	'admin/account/changepassword/$1';
	elseif($firstSlug == 'change-password-verify-otp'):  
		$route['change-password-verify-otp'] 						= 	'admin/account/changepasswordverifyotp';
	
	else: 
		require_once(BASEPATH.'database/DB.php');
		$db 					=	& DB();

		$newCurUrl				=	explode('/tgpapp/',$_SERVER['REQUEST_URI']); 
		if($_SERVER['SERVER_NAME']=='localhost'):
			$classFunction		=	isset($newCurUrl[1])?$newCurUrl[1]:'';
		else: 
			$classFunction		=	isset($newCurUrl[1])?$newCurUrl[1]:'';
		endif;  
		$classFunction			=	strpos($classFunction,'/?')?explode('/?',$classFunction):explode('?',$classFunction);
		if($classFunction[0]):	
			$defaultClassArray	=	array('department','designation','subadmin');
			$classArray			=	explode('/',$classFunction[0]);
			if(isset($classArray[0])):
				$classQuery 	= 	$db->select('module_id')->from('admin_module')->where("module_name = '".$classArray[0]."'")->get();
				$classData		= 	$classQuery->result();
				$subClassQuery 	= 	$db->select('child_module_id')->from('admin_module_child')->where("module_name = '".$classArray[0]."'")->get();
				$subClassData	= 	$subClassQuery->result();  
				if($classData):		
					$route[$classFunction[0]] 						= 	'admin/'.$classFunction[0]; 
				elseif($subClassData):	
					$route[$classFunction[0]] 						= 	'admin/'.$classFunction[0]; 
				elseif(in_array($classArray[0],$defaultClassArray)):  
					$route[$classFunction[0]] 						= 	'admin/'.$classFunction[0]; 
				endif;
			endif;
		endif;
	endif;
endif;
//echo '<pre>';  print_r($route); die;