<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Examlist extends CI_Controller {

	public function  __construct() 
	{ 
		parent:: __construct();
		//error_reporting(E_ALL ^ E_NOTICE);  
		error_reporting(0); 
		$this->load->model(array('admin_model','emailtemplate_model','sms_model','notification_model'));
		$this->lang->load('statictext', 'admin');
		$this->load->helper('common');
	} 

	/* * *********************************************************************
	 * * Function name 	: index
	 * * Developed By 	: Afsar Ali
	 * * Purpose  		: This function used for IL Talks
	 * * Date 			: 07 SEPT 2022
	 * * **********************************************************************/
	public function index()
	{	
		$this->admin_model->authCheck('view_data');
		$this->admin_model->getPermissionType($data); 
		$data['error'] 						= 	'';
		$data['activeMenu'] 				= 	'adminquestionslist';
		$data['activeSubMenu'] 				= 	'adminquestionslist';
		
		if($this->input->get('searchValue')):
			$sValue							=	$this->input->get('searchValue');
			$whereCon['like']			 	= 	"(ftable.question LIKE '%".$sValue."%')
												OR ftable.option_A LIKE '%".$sValue."%'
												OR ftable.option_B LIKE '%".$sValue."%'
												OR ftable.option_C LIKE '%".$sValue."%'
												OR ftable.option_D LIKE '%".$sValue."%'
												OR ftable.answer LIKE '%".$sValue."%'
												OR ftable.mark LIKE '%".$sValue."%'";

			$data['searchField'] 			= 	$sField;
			$data['searchValue'] 			= 	$sValue;
		else:
			$whereCon['like']		 		= 	"";
			$data['searchField'] 			= 	'';
			$data['searchValue'] 			= 	'';
		endif;
				
		$whereCon['where']		 			= 	"";		
		$shortField 						= 	"ftable.id DESC";
		
		$baseUrl 							= 	getCurrentControllerPath('index');
		$this->session->set_userdata('questionsBLData',currentFullUrl());
		$qStringdata						=	explode('?',currentFullUrl());
		$suffix								= 	$qStringdata[1]?'?'.$qStringdata[1]:'';
		$tblName 							= 	'questions as ftable';
		$con 								= 	'';
		
		$totalRows 							= 	$this->common_model->getData('count',$tblName,$whereCon,$shortField,'0','0');
		
		if($this->input->get('showLength') == 'All'):
			$perPage	 					= 	$totalRows;
			$data['perpage'] 				= 	$this->input->get('showLength');  
		elseif($this->input->get('showLength')):
			$perPage	 					= 	$this->input->get('showLength'); 
			$data['perpage'] 				= 	$this->input->get('showLength'); 
		else:
			$perPage	 					= 	SHOW_NO_OF_DATA;
			$data['perpage'] 				= 	SHOW_NO_OF_DATA; 
		endif;
		$uriSegment 						= 	getUrlSegment();
	    $data['PAGINATION']					=	adminPagination($baseUrl,$suffix,$totalRows,$perPage,$uriSegment);

       if ($this->uri->segment(getUrlSegment())):
           $page = $this->uri->segment(getUrlSegment());
       else:
           $page = 0;
       endif;
		
		$data['forAction'] 					= 	$baseUrl; 
		if($totalRows):
			$first							=	(int)($page)+1;
			$data['first']					=	$first;
			
			if($data['perpage'] == 'All'):
				$pageData 					=	$totalRows;
			else:
				$pageData 					=	$data['perpage'];
			endif;
			
			$last							=	((int)($page)+$pageData)>$totalRows?$totalRows:((int)($page)+$pageData);
			$data['noOfContent']			=	'Showing '.$first.'-'.$last.' of '.$totalRows.' items';
		else:
			$data['first']					=	1;
			$data['noOfContent']			=	'';
		endif;
		$data['ALLDATA'] 					= 	$this->common_model->getData('multiple',$tblName,$whereCon,$shortField,$perPage,$page); 
		$this->layouts->set_title('Manage Questions');
		$this->layouts->admin_view('questionslist/index',array(),$data);
	}	// END OF FUNCTION
	
	/* * *********************************************************************
	 * * Function name 	: addeditdata
	 * * Developed By 	: Afsar Ali
	 * * Purpose  		: This function used for add edit data
	 * * Date 			: 07 SEPT 2022
	 * * **********************************************************************/
	public function addeditdata($editId='')
	{		
		$data['error'] 						= 	'';
		$data['activeMenu'] 				= 	'adminquestionslist';
		$data['activeSubMenu'] 				= 	'adminquestionslist';
		
		if($editId):
			$this->admin_model->authCheck('edit_data');
			$data['EDITDATA']		=	$this->common_model->getDataByParticularField('questions','id',(int)$editId);
		else:
			$this->admin_model->authCheck('add_data');
		endif;

		if($this->input->post('SaveChanges')):
			//echo'<pre>'; print_r($_POST); die();
			$error					=	'NO';
			$this->form_validation->set_rules('question', 'Question', 'trim|required');
			$this->form_validation->set_rules('option_A', 'Option A', 'trim|required');
			$this->form_validation->set_rules('option_B', 'Option B', 'trim|required');
			$this->form_validation->set_rules('option_C', 'Option C', 'trim|required');
			$this->form_validation->set_rules('option_D', 'Option D', 'trim|required');
			$this->form_validation->set_rules('answer', 'Answer', 'trim|required');
			$this->form_validation->set_rules('mark', 'Mark Contains', 'trim|required');
			if($this->input->post('negative_mark')){
				$this->form_validation->set_rules('negative_mark', 'Negative Mark', 'trim|required');
			}

			if($this->form_validation->run() && $error == 'NO'): 
				//echo "<pre>";print_r($_POST); die();				
				$param['question']			= 	$this->input->post('question');	
				$param['option_A']			= 	$this->input->post('option_A');
				$param['option_B']			= 	$this->input->post('option_B');
				$param['option_C']			= 	$this->input->post('option_C');
				$param['option_D']			= 	$this->input->post('option_D');
				$param['answer']			= 	$this->input->post('answer');
				$param['mark']				= 	$this->input->post('mark');
				if($this->input->post('negative_mark')){
					$param['negative_mark']	= 	$this->input->post('negative_mark');
				}

				if($this->input->post('CurrentDataID') ==''):
					$param['creation_ip']		=	currentIp();
					$param['creation_date']		=	(int)$this->timezone->utc_time();//currentDateTime();
					$param['created_by']		=	(int)$this->session->userdata('BL_ADMIN_ID');
					$param['status']			=	'A'; 
					$alastInsertId				=	$this->common_model->addData('questions',$param);
					$this->session->set_flashdata('alert_success',lang('addsuccess'));
				else:
					$TypId					=	$this->input->post('CurrentDataID');
					$param['update_ip']			=	currentIp();
					$param['update_date']		=	(int)$this->timezone->utc_time();//currentDateTime();
					$param['updated_by']		=	(int)$this->session->userdata('BL_ADMIN_ID');  
					$this->common_model->editData('questions',$param,'id',(int)$TypId);
					$this->session->set_flashdata('alert_success',lang('updatesuccess'));
				endif;
				
				redirect(correctLink('questionsBLData',getCurrentControllerPath('index')));
			endif;
		endif;
		
		$this->layouts->set_title($editId?'Edit':'Add'.' Questions');
		$this->layouts->admin_view('questionslist/addeditdata',array(),$data);
	}	// END OF FUNCTION	


	/***********************************************************************
	** Function name 	: changestatus
	** Developed By 	: Afsar Ali
	** Purpose  		: This function used for change status
	** Date 			: 07 SEPT 2022
	************************************************************************/
	function changestatus($changeStatusId='',$statusType='')
	{  
		$this->admin_model->authCheck('edit_data');
		$param['status']		=	$statusType;
		$this->common_model->editData('questions',$param,'id',(int)$changeStatusId);
		$this->session->set_flashdata('alert_success',lang('statussuccess'));
		
		redirect(correctLink('questionsBLData',getCurrentControllerPath('index')));
	}


	/***********************************************************************
	** Function name 	: deletedata
	** Developed By 	: Afsar Ali
	** Purpose  		: This function used for delete data
	** Date 			: 07 SEPT 2022
	************************************************************************/
	function deletedata($deleteId='')
	{  
		$this->admin_model->authCheck('delete_data');

		$this->common_model->deleteData('questions','id',(int)$deleteId);
		$this->session->set_flashdata('alert_success',lang('deletesuccess'));
		
		redirect(correctLink('questionsBLData',getCurrentControllerPath('index')));
	}

}