<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Login extends CI_Controller {

	public function  __construct() 
	{ 
		parent:: __construct();
		//error_reporting(E_ALL ^ E_NOTICE);  
		error_reporting(0);  
		$this->load->model(array('admin_model','emailtemplate_model','sms_model','notification_model'));
		$this->lang->load('statictext', 'admin');
		$this->load->helper('common');
	} 
	
	/* * *********************************************************************
	 * * Function name : login
	 * * Developed By : Manoj Kumar
	 * * Purpose  : This function for login
	 * * Date : 23 JUNE 2022
	 * * **********************************************************************/
	public function index()
	{	
		if($this->session->userdata('BL_ADMIN_ID')) redirect($this->session->userdata('BL_ADMIN_CURRENT_PATH').'maindashboard');
		$data['error'] 						= 	'';
		/*-----------------------------------Login ---------------*/
		if($this->input->post('loginFormSubmit')):	
			//Set rules
			$this->form_validation->set_rules('userEmail', 'email', 'trim|required');
			$this->form_validation->set_rules('userPassword', 'password', 'trim|required');
			
			if($this->form_validation->run()):	
				$result		=	$this->admin_model->Authenticate($this->input->post('userEmail')); 
				if($result): 
					if($this->admin_model->decryptsPassword($result['admin_password']) != $this->input->post('userPassword')):
						$data['error'] = lang('invalidpassword');	
					elseif($result['status'] != 'A'):	
						$data['error'] = lang('accountblock');	
					else:	

						$param['last_login_ip']				=	currentIp();
					$param['last_login_date']			=	(int)$this->timezone->utc_time();//currentDateTime();
					$param['admin_password_otp']		=	'';
					$this->common_model->editData('admin',$param,'admin_id',$result['admin_id']);

					############	LOGIN IN NEW SYSTEM 	############
					$loginParam['admin_id']				=	(int)$result['admin_id'];
					$loginParam['admin_token']			=	generateToken();
					$loginParam['login_status']			=	'Login';
					$loginParam['login_datetime']		=	(int)$this->timezone->utc_time();//currentDateTime();
					$loginParam['login_ip']				=	currentIp();
					$logininsertId						=	$this->common_model->addData('admin_login_log',$loginParam);

					$currentPath 		=	getCurrentBasePath();
					
					$this->session->set_userdata(array(
								'BL_ADMIN_LOGGED_IN'		=>	true,
								'BL_ADMIN_ID'				=>	$result['admin_id'],
								'BL_ADMIN_TITLE'			=>	$result['admin_title'],
								'BL_ADMIN_FIRST_NAME'		=>	$result['admin_first_name'],
								'BL_ADMIN_MIDDLE_NAME'		=>	$result['admin_middle_name'],
								'BL_ADMIN_LAST_NAME'		=>	$result['admin_last_name'],
								'BL_ADMIN_EMAIL'			=>	$result['admin_email'],
								'BL_ADMIN_MOBILE'			=>	$result['admin_phone'],
								'BL_ADMIN_IMAGE'			=>	$result['admin_image'],
								'BL_ADMIN_ADDRESS'			=>	$result['admin_address'],
								'BL_ADMIN_CITY'				=>	$result['admin_city'],
								'BL_ADMIN_STATE'			=>	$result['admin_state'],
								'BL_ADMIN_COUNTRY'			=>	$result['admin_country'],
								'BL_ADMIN_ZIPCODE'			=>	$result['admin_pincode'],
								'BL_ADMIN_TYPE'				=>	$result['admin_type'],
								'BL_ADMIN_CURRENT_PATH'		=>	$currentPath,
								'BL_ADMIN_USER_TYPE'		=>	'',
								'BL_ADMIN_LAST_LOGIN'		=>	$result['last_login_date'].' ('.$result['last_login_ip'].')'));

					setcookie('BL_ADMIN_LOGIN_TOKEN',$loginParam['admin_token'],time()+60*60*24*100,'/');

					if($_COOKIE['BL_ADMIN_REFERENCE_PAGES']):
						redirect(base_url().$_COOKIE['BL_ADMIN_REFERENCE_PAGES']);
					else:
					//	redirect($currentPath.'maindashboard');
					redirect(base_url('admin/account/maindashboard'));
					endif;

					endif;
				else:
					$data['error'] = lang('invalidlogindetails');
				endif;			
			endif;
		endif;
		
		$this->layouts->set_title('Login');
		$this->layouts->admin_view('account/login',array(),$data,'login');
	}

	/* * *********************************************************************
	 * * Function name : loginverifyotp
	 * * Developed By : Manoj Kumar
	 * * Purpose  : This function used for admin password recover
	 * * Date : 23 JUNE 2022
	 * * **********************************************************************/
	public function loginverifyotp()
	{	
		if($this->session->userdata('BL_ADMIN_ID')) redirect($this->session->userdata('BL_ADMIN_CURRENT_PATH').'maindashboard');
		$data['error'] 						= 	'';
		$data['recovererror'] 				=	''; 

		/*-----------------------------------recover password ---------------*/
		if($this->input->post('otpVerificationFormSubmit')):	
			//Set rules
			$this->form_validation->set_rules('userOtp', 'otp', 'trim|required|min_length[4]|max_length[4]');
			
			if($this->form_validation->run()):	
				$result		=	$this->admin_model->checkOTP($this->input->post('userOtp'));
				if($result): 
					$this->session->unset_userdata(array('otpType','otpAdminId','otpAdminMobile'));

					$param['last_login_ip']				=	currentIp();
					$param['last_login_date']			=	(int)$this->timezone->utc_time();//currentDateTime();
					$param['admin_password_otp']		=	'';
					$this->common_model->editData('admin',$param,'admin_id',$result['admin_id']);

					############	LOGIN IN NEW SYSTEM 	############
					$loginParam['admin_id']				=	(int)$result['admin_id'];
					$loginParam['admin_token']			=	generateToken();
					$loginParam['login_status']			=	'Login';
					$loginParam['login_datetime']		=	(int)$this->timezone->utc_time();//currentDateTime();
					$loginParam['login_ip']				=	currentIp();
					$logininsertId						=	$this->common_model->addData('admin_login_log',$loginParam);

					$currentPath 		=	getCurrentBasePath();
					
					$this->session->set_userdata(array(
								'BL_ADMIN_LOGGED_IN'		=>	true,
								'BL_ADMIN_ID'				=>	$result['admin_id'],
								'BL_ADMIN_TITLE'			=>	$result['admin_title'],
								'BL_ADMIN_FIRST_NAME'		=>	$result['admin_first_name'],
								'BL_ADMIN_MIDDLE_NAME'		=>	$result['admin_middle_name'],
								'BL_ADMIN_LAST_NAME'		=>	$result['admin_last_name'],
								'BL_ADMIN_EMAIL'			=>	$result['admin_email'],
								'BL_ADMIN_MOBILE'			=>	$result['admin_phone'],
								'BL_ADMIN_IMAGE'			=>	$result['admin_image'],
								'BL_ADMIN_ADDRESS'			=>	$result['admin_address'],
								'BL_ADMIN_CITY'				=>	$result['admin_city'],
								'BL_ADMIN_STATE'			=>	$result['admin_state'],
								'BL_ADMIN_COUNTRY'			=>	$result['admin_country'],
								'BL_ADMIN_ZIPCODE'			=>	$result['admin_pincode'],
								'BL_ADMIN_TYPE'				=>	$result['admin_type'],
								'BL_ADMIN_CURRENT_PATH'		=>	$currentPath,
								'BL_ADMIN_USER_TYPE'		=>	'',
								'BL_ADMIN_LAST_LOGIN'		=>	$result['last_login_date'].' ('.$result['last_login_ip'].')'));

					setcookie('BL_ADMIN_LOGIN_TOKEN',$loginParam['admin_token'],time()+60*60*24*100,'/');

					if($_COOKIE['BL_ADMIN_REFERENCE_PAGES']):
						redirect(base_url().$_COOKIE['BL_ADMIN_REFERENCE_PAGES']);
					else:
						redirect($currentPath.'maindashboard');
					endif;
				else:
					$data['recovererror'] = lang('invalidotp');
				endif;
			endif;
		endif;
		
		$this->layouts->set_title('Password Recover');
		$this->layouts->admin_view('account/loginverifyotp',array(),$data,'login');
	}	// END OF FUNCTION

	/* * *********************************************************************
	 * * Function name : resendotp
	 * * Developed By : Manoj Kumar
	 * * Purpose  : This function used for resend otp
	 * * Date : 23 JUNE 2022
	 * * **********************************************************************/
	public function resendotp()
	{	
		if(sessionData('otpType') && sessionData('otpAdminId') && sessionData('otpAdminMobile')):
			$param['admin_password_otp']	=	(int)'4321';//(int)generateRandomString(4,'n');
			$this->common_model->editData('admin',$param,'admin_id',(int)sessionData('otpAdminId'));

			if(sessionData('otpType') == 'Login'):
				$this->sms_model->sendLoginOtpSmsToUser(sessionData('otpAdminMobile'),$param['admin_password_otp']);
			elseif(sessionData('otpType') == 'Forgot Password'):
				$this->sms_model->sendForgotPasswordOtpSmsToUser(sessionData('otpAdminMobile'),$param['admin_password_otp']);
			elseif(sessionData('otpType') == 'Change Password'):
				$this->sms_model->sendChangePasswordOtpSmsToUser(sessionData('otpAdminMobile'),$param['admin_password_otp']);
			endif;

			$this->session->set_flashdata('alert_success',lang('sendotptomobile').sessionData('otpAdminMobile'));
		endif;
		redirect($_SERVER['HTTP_REFERER']);
	}	// END OF FUNCTION
	
	/* * *********************************************************************
	 * * Function name : forgotpassword
	 * * Developed By : Manoj Kumar
	 * * Purpose  : This function used for admin forgot password
	 * * Date : 23 JUNE 2022
	 * * **********************************************************************/
	public function forgotpassword()
	{	
		if($this->session->userdata('BL_ADMIN_ID')) redirect($this->session->userdata('BL_ADMIN_CURRENT_PATH').'maindashboard');
		$data['error'] 						= 	'';
		$data['forgoterror'] 				= 	'';

		/*-----------------------------------Forgot password ---------------*/
		if($this->input->post('recoverformSubmit')):	
			//Set rules
			$this->form_validation->set_rules('forgotMobile', 'Mobile', 'trim|required|min_length[10]|max_length[10]');
			
			if($this->form_validation->run()):	
				$result		=	$this->common_model->getDataByParticularField('admin','admin_phone',$this->input->post('forgotMobile'));
				if($result):
					if($result['status'] != 'A'):	
						$data['forgoterror'] = lang('accountblock');	
					else:
						$param['admin_password_otp']		=	(int)'4321';//(int)generateRandomString(4,'n');
						$this->common_model->editData('admin',$param,'admin_id',(int)$result['admin_id']);

						$this->sms_model->sendForgotPasswordOtpSmsToUser($result['admin_phone'],$param['admin_password_otp']);

						$this->session->set_userdata(array('otpType'=>'Forgot Password','otpAdminId'=>$result['admin_id'],'otpAdminMobile'=>$result['admin_phone']));

						$this->session->set_flashdata('alert_success',lang('sendotptomobile').$result['admin_phone']);
						redirect(getCurrentBasePath().'password-recover');
					endif;
				else:
					$data['forgoterror'] = lang('invalidmobile');
				endif;
			endif;
		endif;
		
		$this->layouts->set_title('Forgot Password');
		$this->layouts->admin_view('account/forgotpassword',array(),$data,'login');
	}	// END OF FUNCTION

	/* * *********************************************************************
	 * * Function name : passwordrecover
	 * * Developed By : Manoj Kumar
	 * * Purpose  : This function used for admin password recover
	 * * Date : 23 JUNE 2022
	 * * **********************************************************************/
	public function passwordrecover()
	{	
		if($this->session->userdata('BL_ADMIN_ID')) redirect($this->session->userdata('BL_ADMIN_CURRENT_PATH').'maindashboard');
		$data['error'] 						= 	'';
		$data['recovererror'] 				= 	'';
		$data['forgotsuccess'] 				= 	'';

		/*-----------------------------------recover password ---------------*/
		if($this->input->post('passwordRecoverFormSubmit')):	
			//Set rules
			$this->form_validation->set_rules('userOtp', 'otp', 'trim|required|min_length[4]|max_length[4]');
			$this->form_validation->set_rules('userPassword', 'New password', 'trim|required|min_length[6]|max_length[25]');
			$this->form_validation->set_rules('userConfPassword', 'Confirm password', 'trim|required|min_length[6]|matches[userPassword]');
			
			if($this->form_validation->run()):	
				$result		=	$this->admin_model->checkOTP($this->input->post('userOtp'));
				if($result):
					$this->session->unset_userdata(array('otpType','otpAdminId','otpAdminMobile'));

					$param['admin_password']		=	$this->admin_model->encriptPassword($this->input->post('userPassword'));
					$param['admin_password_otp']	=	'';
					$this->common_model->editData('admin',$param,'admin_id',(int)$result['admin_id']);
							
					$this->session->set_flashdata('alert_success',lang('passrecoversuccess'));
					redirect(getCurrentBasePath().'login');
				else:
					$data['recovererror'] = lang('invalidotp');
				endif;
			endif;
		endif;
		
		$this->layouts->set_title('Password Recover');
		$this->layouts->admin_view('account/passwordrecover',array(),$data,'login');
	}	// END OF FUNCTION
	
	/***********************************************************************
	** Function name : logout
	** Developed By : Manoj Kumar
	** Purpose  : This function used for logout
	** Date : 23 JUNE 2022
	************************************************************************/
	function logout()
	{
		$logoutParam['admin_token']			=	'';
		$logoutParam['login_status']		=	'Logout';
		$logoutParam['logout_datetime']		=	(int)$this->timezone->utc_time();//currentDateTime();
		$logoutParam['logout_ip']			=	currentIp();

		$logoutuWhere['login_status']		=	'Login';
		$logoutuWhere['admin_token']		=	$_COOKIE['BL_ADMIN_LOGIN_TOKEN'];
		$logoutuWhere['admin_id']			=	(int)$this->session->userdata('BL_ADMIN_ID');
		$this->common_model->editDataByMultipleCondition('admin_login_log',$logoutParam,$logoutuWhere);

		setcookie('BL_ADMIN_LOGIN_TOKEN','',time()-60*60*24*100,'/');
		setcookie('BL_ADMIN_REFERENCE_PAGES','',time()-60*60*24*100,'/');
		
		$this->session->unset_userdata(array('otpType','otpAdminId','otpAdminMobile','changeNewPassword'));
		$this->session->unset_userdata(array('BL_ADMIN_LOGGED_IN',
											 'BL_ADMIN_ID',
											 'BL_ADMIN_TITLE',
											 'BL_ADMIN_FIRST_NAME',
											 'BL_ADMIN_MIDDLE_NAME',
											 'BL_ADMIN_LAST_NAME',
											 'BL_ADMIN_EMAIL',
											 'BL_ADMIN_MOBILE',
											 'BL_ADMIN_IMAGE',
											 'BL_ADMIN_ADDRESS',
											 'BL_ADMIN_CITY',
											 'BL_ADMIN_STATE',
											 'BL_ADMIN_COUNTRY',
											 'BL_ADMIN_ZIPCODE',
											 'BL_ADMIN_TYPE',
											 'BL_ADMIN_CURRENT_PATH',
											 'BL_ADMIN_USER_TYPE',
											 'BL_ADMIN_LAST_LOGIN'));
		//redirect(getCurrentBasePath().'login');
		redirect(base_url('admin/login'));
	}	// END OF FUNCTION
}