<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Lowers extends CI_Controller {
	
	var $postdata;
	var $user_agent; 
	var $request_url; 
	var $method_name;
	
	public function  __construct() 	
	{ 
		parent:: __construct();
		//error_reporting(E_ALL ^ E_NOTICE);  
		error_reporting(0); 
		$this->load->model(array('sms_model','notification_model','emailtemplate_model'));
		$this->load->helper('apidata');
		$this->lang->load('statictext', 'api');

		$this->user_agent 		= 	$_SERVER['HTTP_USER_AGENT'];
		$this->request_url 		= 	$_SERVER['REDIRECT_URL'];
		$this->method_name 		= 	$_SERVER['REDIRECT_QUERY_STRING'];

		$this->load->library('generatelogs',array('type'=>'lowers'));
	}

	
	/* * *********************************************************************
	 * * Function name : getStateList
	 * * Developed By : Manoj Kumar
	 * * Purpose  : This function used for get State List
	 * * Date : 13 JUNE 2022
	 * * **********************************************************************/
	public function getStateList()
	{	
		$apiHeaderData 		=	getApiHeaderData();
		$this->generatelogs->putLog('APP',logOutPut($_POST));
		$result 							= 	array();	
		if(requestAuthenticate(APIKEY,'GET')):
			$whereCon['where']		 		= 	"status = 'A'";	
			$result['stateList']    		=   $this->common_model->getData('multiple','state as ftable',$whereCon,'state_title ASC',0,0);

			echo outPut(1,lang('SUCCESS_CODE'),lang('SUCCESS_MSG'),$result);
		else:
			echo outPut(0,lang('FORBIDDEN_CODE'),lang('FORBIDDEN_MSG'),$result);
		endif;
	}

	/* * *********************************************************************
	 * * Function name : getCityList
	 * * Developed By : Manoj Kumar
	 * * Purpose  : This function used for get Lower City List
	 * * Date : 13 JUNE 2022
	 * * **********************************************************************/
	public function getCityList()
	{	
		$apiHeaderData 		=	getApiHeaderData();
		$this->generatelogs->putLog('APP',logOutPut($_POST));
		$result 							= 	array();	
		if(requestAuthenticate(APIKEY,'GET')):
			if($this->input->get('state_id') == ''): 
				echo outPut(0,lang('SUCCESS_CODE'),lang('STATE_ID_EMPTY'),$result);
			else:
				$whereCon['where']		 		= 	"state_id = '".$this->input->get('state_id')."' AND status = 'A'";	
				$result['cityList']    	=   $this->common_model->getData('multiple','city as ftable',$whereCon,'city_name ASC',0,0);

				echo outPut(1,lang('SUCCESS_CODE'),lang('SUCCESS_MSG'),$result);
			endif;
		else:
			echo outPut(0,lang('FORBIDDEN_CODE'),lang('FORBIDDEN_MSG'),$result);
		endif;
	}

	/* * *********************************************************************
	 * * Function name : getLowerTypesList
	 * * Developed By : Manoj Kumar
	 * * Purpose  : This function used for get Lower Types List
	 * * Date : 13 JUNE 2022
	 * * **********************************************************************/
	public function getLowerTypesList()
	{	
		$apiHeaderData 		=	getApiHeaderData();
		$this->generatelogs->putLog('APP',logOutPut($_POST));
		$result 							= 	array();	
		if(requestAuthenticate(APIKEY,'GET')):
			$whereCon['where']		 		= 	"status = 'A'";	
			$result['lowerTypesList']    	=   $this->common_model->getData('multiple','types_of_lawyers as ftable',$whereCon,'lower_type_name ASC',0,0);

			echo outPut(1,lang('SUCCESS_CODE'),lang('SUCCESS_MSG'),$result);
		else:
			echo outPut(0,lang('FORBIDDEN_CODE'),lang('FORBIDDEN_MSG'),$result);
		endif;
	}

	/* * *********************************************************************
	 * * Function name 	: getLowerList
	 * * Developed By 	: Afsar Ali
	 * * Purpose  		: This function used for get Lower List
	 * * Date 			: 28 JUNE 2022
	 * * **********************************************************************/
	public function getLowerList()
	{	
		$apiHeaderData 		=	getApiHeaderData();
		$this->generatelogs->putLog('APP',logOutPut($_POST));
		$result 							= 	array();	
		if(requestAuthenticate(APIKEY,'POST')):
			if ($this->input->post('state_id') == ''): 
				echo outPut(0,lang('SUCCESS_CODE'),lang('STATE_ID_EMPTY'),$result);	
			elseif($this->input->post('city_id') == ''):
				echo outPut(0,lang('SUCCESS_CODE'),lang('CITY_ID_EMPTY'),$result);	
			elseif($this->input->post('lower_type_id') == ''):
				echo outPut(0,lang('SUCCESS_CODE'),lang('LOWER_TYPE_ID_EMPTY'),$result);
			else:
				$whereCon['where']		 		= 	array(
													'lower_type_id' => (int)$this->input->post('lower_type_id'),
													'lower_state'	=> $this->input->post('state_id'),
													'lower_city'	=> $this->input->post('city_id'),
													);
				$result['lowerList']    		=   $this->common_model->getData('multiple','lawyers as ftable',$whereCon,'lower_name ASC',0,0);
				echo outPut(1,lang('SUCCESS_CODE'),lang('SUCCESS_MSG'),$result);	
			endif;
		else:
			echo outPut(0,lang('FORBIDDEN_CODE'),lang('FORBIDDEN_MSG'),$result);
		endif;
	}


}