<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Mootcourt extends CI_Controller {
	
	var $postdata;
	var $user_agent; 
	var $request_url; 
	var $method_name;
	
	public function  __construct() 	
	{ 
		parent:: __construct();
		//error_reporting(E_ALL ^ E_NOTICE);  
		error_reporting(0); 
		$this->load->model(array('sms_model','notification_model','emailtemplate_model'));
		$this->load->helper('apidata');
		$this->lang->load('statictext', 'api');

		$this->user_agent 		= 	$_SERVER['HTTP_USER_AGENT'];
		$this->request_url 		= 	$_SERVER['REDIRECT_URL'];
		$this->method_name 		= 	$_SERVER['REDIRECT_QUERY_STRING'];

		$this->load->library('generatelogs',array('type'=>'lowers'));
	}
	
	/* * *********************************************************************
	 * * Function name 	: getMootCourtList
	 * * Developed By 	: Manoj Kumar
	 * * Purpose  		: This function used for get Moot Court List
	 * * Date 			: 13 JUNE 2022
	 * * **********************************************************************/
	public function getMootCourtList()
	{	
		$apiHeaderData 		=	getApiHeaderData();
		$this->generatelogs->putLog('APP',logOutPut($_POST));
		$result 							= 	array();	
		if(requestAuthenticate(APIKEY,'GET')):
			$whereCon['where']		 	= 	"status = 'A'";
			$fields 					=	"ftable.mootcourt_id,ftable.mootcourt_title,ftable.mootcourt_date,ftable.mootcourt_time";
			$result['mootcourt']    		=   $this->common_model->getParticularFieldData('multiple',$fields,'mootcourt as ftable',$whereCon,'mootcourt_id DESC',0,0);

			echo outPut(1,lang('SUCCESS_CODE'),lang('SUCCESS_MSG'),$result);
		else:
			echo outPut(0,lang('FORBIDDEN_CODE'),lang('FORBIDDEN_MSG'),$result);
		endif;
	}

	/* * *********************************************************************
	 * * Function name 	: getMootCourtDetailsData
	 * * Developed By 	: Afsar Ali
	 * * Purpose  		: This function used for get Lower List
	 * * Date 			: 28 JUNE 2022
	 * * **********************************************************************/
	public function getMootCourtDetailsData()
	{	
		$apiHeaderData 		=	getApiHeaderData();
		$this->generatelogs->putLog('APP',logOutPut($_POST));
		$result 							= 	array();	
		if(requestAuthenticate(APIKEY,'POST')):
			if ($this->input->post('mootcourt_id') == ''): 
				echo outPut(0,lang('SUCCESS_CODE'),lang('MOOTCOURT_ID_EMPTY'),$result);	
			else:
				$whereCon['where']		 	= 	"mootcourt_id = ".$this->input->post('mootcourt_id');
				$result['mootcourt']    	=   $this->common_model->getData('single','mootcourt as ftable',$whereCon,[],0,0);
				if(!empty($result['mootcourt'])):
					echo outPut(1,lang('SUCCESS_CODE'),lang('SUCCESS_MSG'),$result);
				else:
					echo outPut(0,lang('SUCCESS_CODE'),lang('DATA_NOT_FOUND'),$result);
				endif;
			endif;
		else:
			echo outPut(0,lang('FORBIDDEN_CODE'),lang('FORBIDDEN_MSG'),$result);
		endif;
	}


}