<?php
if(!defined('BASEPATH')) exit('No direct script access allowed');
class Common_model extends CI_Model
{
	public function __construct()
	{
		parent::__construct(); 
	}

	function milliseconds() {
	    $mt = explode(' ', microtime());
	    return ((int)$mt[1]) * 1000 + ((int)round($mt[0] * 1000));
	}

	function microseconds() {
	    $mt = explode(' ', microtime());
	    return ((int)$mt[1]) * 1000000 + ((int)round($mt[0] * 1000000));
	}

	/***********************************************************************
	** Function Name returnIntegerEncryptValue
	** Developed By : Manoj Kumar
	** Input Parameters 
	** 1. inputInteger = The integer value which need to encrypted
	** 2. returnLength = THe number of digit which need to be return from functon.
	** Function Process :- The function will take integr input and multiply it with current unixtimestamp.
	** The new value will be encrypt using md5 which return 32 bit string, The encrypt string convert to ASCII
	** value and then the desire lenght sub string will be return by function.
	** Date : 23 JUNE 2022
	************************************************************************/
	public function returnIntegerEncryptValue($inputInteger, $returnLength = 16)
	{
		$returnEncryptInterValue = '';
		$lenghtCounter = 0;
		$currentTimeStamp = $this->microseconds();//$this->milliseconds();//time();
		$vauleToBeEncrypted = $inputInteger * $currentTimeStamp;
		$encryptedString = md5($vauleToBeEncrypted);
		$encryptedStringCharArray = str_split($encryptedString);
		foreach($encryptedStringCharArray as $charValue):
			$asciiValue = ord($charValue);
			$asciiValueLength = strlen($asciiValue);
			$lenghtCounter = $lenghtCounter + $asciiValueLength;
			if($lenghtCounter < $returnLength):	
				$returnEncryptInterValue = $returnEncryptInterValue.$asciiValue;
				$returnEncryptInterValue.' rln '.strlen($returnEncryptInterValue);
			else:
				break;
			endif;
		endforeach;
		$remaingNumberOfDigits = $returnLength - strlen($returnEncryptInterValue);
		if($remaingNumberOfDigits > 0):
			for($remaingDigitsCounter = 0; $remaingDigitsCounter < $remaingNumberOfDigits; $remaingDigitsCounter++):
				$returnEncryptInterValue = $returnEncryptInterValue .rand ( 0 , 9);
			endfor;
		endif;
		return $returnEncryptInterValue;
	}	// END OF FUNCTION

	/***********************************************************************
	** Function name : addData
	** Developed By : Manoj Kumar
	** Purpose  : This function used for add data
	** Date : 23 JUNE 2022
	************************************************************************/
	public function addData($tableName='',$param=array())
	{
		$this->db->insert($tableName,$param);
		return $this->db->insert_id();
	}	// END OF FUNCTION
	
	/* * *********************************************************************
	 * * Function name : editData
	 * * Developed By : Manoj Kumar
	 * * Purpose  : This function used for edit data
	 * * Date : 23 JUNE 2022
	 * * **********************************************************************/
	function editData($tableName='',$param='',$fieldName='',$fieldValue='')
	{ 

		
		$this->db->where($fieldName,$fieldValue);
		$this->db->update($tableName,$param);
		return true;
	}	// END OF FUNCTION
	
	/***********************************************************************
	** Function name : editDataByMultipleCondition
	** Developed By : Manoj Kumar
	** Purpose  : This function used for edit data by multiple condition
	** Date : 23 JUNE 2022
	************************************************************************/
	function editDataByMultipleCondition($tableName='',$param=array(),$whereCondition=array())
	{
		$this->db->where($whereCondition);
		$this->db->update($tableName,$param);
		return true;
	}	// END OF FUNCTION

	/***********************************************************************
	** Function name : editMultipleDataByMultipleCondition
	** Developed By : Manoj Kumar
	** Purpose  : This function used for edit data by multiple condition
	** Date : 23 JUNE 2022
	************************************************************************/
	function editMultipleDataByMultipleCondition($tableName='',$param=array(),$whereCondition=array())
	{
		$this->db->where($whereCondition);
		$this->db->update($tableName,$param);
		return true;
	}	// END OF FUNCTION

	/***********************************************************************
	** Function name : editMultipleDataByMultipleCondition
	** Developed By : Manoj Kumar
	** Purpose  : This function used for edit data by multiple condition
	** Date : 23 JUNE 2022
	************************************************************************/
	function editMultipleDataBySingleCondition($tableName='',$param='',$fieldName='',$fieldValue='')
	{ 
		$this->db->where($fieldName,$fieldValue);
		$this->db->update($tableName,$param);
		return true;
	}	// END OF FUNCTION
	
	/***********************************************************************
	** Function name : deleteData
	** Developed By : Manoj Kumar
	** Purpose  : This function used for delete data
	** Date : 23 JUNE 2022
	************************************************************************/
	function deleteData($tableName='',$fieldName='',$fieldValue='')
	{
		$this->db->delete($tableName,array($fieldName=>$fieldValue));
		return true;
	}	// END OF FUNCTION
	
	/***********************************************************************
	** Function name : deleteParticularData
	** Developed By : Manoj Kumar
	** Purpose  : This function used for delete particular data
	** Date : 23 JUNE 2022
	************************************************************************/
	function deleteParticularData($tableName='',$fieldName='',$fieldValue='')
	{ 
		$this->db->delete($tableName,array($fieldName=>$fieldValue));
		return true;
	}	// END OF FUNCTION
	
	/***********************************************************************
	** Function name : deleteByMultipleCondition
	** Developed By : Manoj Kumar
	** Purpose  : This function used for delete by multiple condition
	** Date : 23 JUNE 2022
	************************************************************************/
	function deleteByMultipleCondition($tableName='',$whereCondition=array())
	{
		$this->db->delete($tableName,$whereCondition);
		return true;
	}	// END OF FUNCTION
	
	/***********************************************************************
	** Function name: getDataByParticularField
	** Developed By: Manoj Kumar
	** Purpose: This function used for get data by encryptId
	** Date : 23 JUNE 2022
	************************************************************************/
	public function getDataByParticularField($tableName='',$fieldName='',$fieldValue='')
	{  
		$this->db->select('*');
		$this->db->from($tableName);	
		$this->db->where($fieldName,$fieldValue);
		$query = $this->db->get();
		if($query->num_rows() > 0):
			return $query->row_array();
		else:
			return false;
		endif;
	}	// END OF FUNCTION

	/***********************************************************************
	** Function name: getSingleDataByParticularField
	** Developed By: Manoj Kumar
	** Purpose: This function used for get Single Data By Particular Field
	** Date : 23 JUNE 2022
	************************************************************************/
	public function getSingleDataByParticularField($fields=array(),$tableName='',$fieldName='',$fieldValue='')
	{  
		if(empty($fields)): $fields 	=	'*'; endif; 
		$this->db->select($fields);
		$this->db->from($tableName);	
		$this->db->where($fieldName,$fieldValue);
		$query = $this->db->get();
		if($query->num_rows() > 0):
			return $query->row_array();
		else:
			return false;
		endif;
	}	// END OF FUNCTION
	
	/***********************************************************************
	** Function name: getDataByQuery
	** Developed By: Manoj Kumar
	** Purpose: This function used for get data by query
	** Date : 23 JUNE 2022
	************************************************************************/
	public function getData($action='',$tbl_name='',$wcon='',$shortField='',$num_page='',$cnt='')
	{  
		$this->db->select('ftable.*');
		$this->db->from($tbl_name);
		if($wcon['where']):		$this->db->where($wcon['where']);	 		endif;
		if($wcon['like']):  	$this->db->where($wcon['like']); 			endif;
		if($shortField):		$this->db->order_by($shortField);			endif;
		if($num_page):			$this->db->limit($num_page,$cnt);			endif;
		//$this->db->group_by('user_id');
		$query = $this->db->get();
		if($action == 'count'):	
			return $query->num_rows();
		elseif($action == 'single'):	
			if($query->num_rows() > 0):
				return $query->row_array();
			else:
				return false;
			endif;
		elseif($action == 'multiple'):	
			if($query->num_rows() > 0):
				return $query->result_array();
			else:
				return false;
			endif;
		else:
			return false;
		endif;

	}	// END OF FUNCTION
	

	public function getDataAttemptedTask($action='',$tbl_name='',$wcon='',$shortField='',$num_page='',$cnt='', $taskkkkk_id='')
	{  
		$this->db->select('ftable.*');
		$this->db->from($tbl_name);
		if($wcon['where']):		$this->db->where($wcon['where']);	 		endif;
		if($wcon['like']):  	$this->db->where($wcon['like']); 			endif;
		if($shortField):		$this->db->order_by($shortField);			endif;
		if($num_page):			$this->db->limit($num_page,$cnt);			endif;
		if($taskkkkk_id):		$this->db->where('task_id', $taskkkkk_id);	endif;
		$this->db->group_by('user_id');
		$query = $this->db->get();
		if($action == 'count'):	
			return $query->num_rows();
		elseif($action == 'single'):	
			if($query->num_rows() > 0):
				return $query->row_array();
			else:
				return false;
			endif;
		elseif($action == 'multiple'):	
			if($query->num_rows() > 0):
				return $query->result_array();
			else:
				return false;
			endif;
		else:
			return false;
		endif;

	}
	/***********************************************************************
	** Function name: getFieldInArray
	** Developed By: Manoj Kumar
	** Purpose: This function used for get data by condition
	** Date : 23 JUNE 2022
	************************************************************************/
	public function getFieldInArray($field='',$tbl_name='',$wcon='')
	{  
		$this->db->select($field);
		$this->db->from($tbl_name);
		if($wcon['where']):	$this->db->where($wcon['where']);	 	endif;
		if($wcon['like']):  $this->db->where($wcon['like']); 		endif;
		$query = $this->db->get();
		if($query->num_rows() > 0):
			$result = $query->result_array();
			foreach($result as $info):
				array_push($returnarray,$info[$field]);
			endforeach;
		endif;
		return $returnarray;
	}	// END OF FUNCTION
	
	/***********************************************************************
	** Function name: getLastOrderByFields
	** Developed By: Manoj Kumar
	** Purpose: This function used for get Last Order By Fields
	** Date : 23 JUNE 2022
	************************************************************************/ 
	public function getLastOrderByFields($field='',$tbl_name='',$fieldName='',$fieldValue='')
	{  
		$this->db->select($field);
		$this->db->from($tbl_name);
		if(isset($fieldName) && isset($fieldValue)):
			$this->db->where($fieldName,$fieldValue);
		endif;
		$this->db->order_by($field.' DESC');
		$query = $this->db->get();
		if($query->num_rows() > 0):
			$result = $query->row_array();
			return $result[$field];
		else:
			return 0;
		endif;

	}	// END OF FUNCTION

	/* * *********************************************************************
	 * * Function name : setAttributeInUse
	 * * Developed By : Manoj Kumar
	 * * Purpose  : This function used for set Attribute In Use
	 * * Date : 23 JUNE 2022
	 * * **********************************************************************/
	function setAttributeInUse($tableName='',$param='',$fieldName='',$fieldValue='')
	{ 
		$paramarray[$param]	=	'Y';
		$this->db->where($fieldName,$fieldValue);
		$this->db->update($tableName,$paramarray);
		return true;
	}	// END OF FUNCTION

	/***********************************************************************
	** Function name: getPaticularFieldByFields
	** Developed By: Manoj Kumar
	** Purpose: This function used for get Paticular Field By Fields
	** Date : 23 JUNE 2022
	************************************************************************/ 
	public function getPaticularFieldByFields($field='',$tbl_name='',$fieldName='',$fieldValue='')
	{  
		$this->db->select($field);
		$this->db->from($tbl_name);
		if(isset($fieldName) && isset($fieldValue)):
			$this->db->where($fieldName,$fieldValue);
		endif;
		$query = $this->db->get();
		if($query->num_rows() > 0):
			$result = $query->row_array();
			return $result[$field];
		else:
			return 0;
		endif;
	}	// END OF FUNCTION

	/***********************************************************************
	** Function name: getParticularFieldByMultipleCondition
	** Developed By: Manoj Kumar
	** Purpose: This function used for get Particular Field By Multiple Condition
	** Date : 23 JUNE 2022
	************************************************************************/
	public function getParticularFieldByMultipleCondition($fields=array(),$tableName='',$wcon='')
	{  
		if(empty($fields)): $fields 	=	'*'; endif; 
		$this->db->select($fields);
		$this->db->from($tableName);
		if($wcon['where']):	$this->db->where($wcon['where']);	 	endif;
		if($wcon['like']):  $this->db->where($wcon['like']); 		endif;
		$query = $this->db->get();
		if($query->num_rows() > 0):
			return $query->row_array();
		else:
			return false;
		endif;
	}	// END OF FUNCTION

	/***********************************************************************
	** Function name: getDataByNewQuery
	** Developed By: Manoj Kumar
	** Purpose: This function used for get data by query
	** Date : 23 JUNE 2022
	************************************************************************/
	public function getDataByNewQuery($fields=array(),$action='',$tbl_name='',$wcon='',$shortField='',$num_page='',$cnt='')
	{  
		if(empty($fields)): $fields 	=	'*'; endif; 
		$this->mongo_db->select($fields);	
		if(isset($wcon['where']) && $wcon['where'])	$this->mongo_db->where($wcon['where']);	
		if(isset($wcon['where_ne']) && $wcon['where_ne'])	$this->mongo_db->where_ne($wcon['where_ne'][0],$wcon['where_ne'][1]);	
		if(isset($wcon['where_or']) && $wcon['where_or'])	$this->mongo_db->where_or($wcon['where_or']);	
		if(isset($wcon['where_between']) && $wcon['where_between'])	$this->mongo_db->where_between($wcon['where_between'][0],$wcon['where_between'][1],$wcon['where_between'][2]);	
		if(isset($wcon['like']) && $wcon['like']):	
			$this->mongo_db->like($wcon['like'][0],$wcon['like'][1],'i',TRUE,TRUE);
		endif;
		if(isset($wcon['where_in']) && $wcon['where_in']):	
			foreach($wcon['where_in'] as $whereInData):
				$this->mongo_db->where_in($whereInData[0],$whereInData[1]);
			endforeach;
		endif;
		if(isset($wcon['where_gte']) && $wcon['where_gte']):	
			foreach($wcon['where_gte'] as $whereGteData):
				$this->mongo_db->where_gte($whereGteData[0],$whereGteData[1]);
			endforeach;
		endif;
		if($shortField)				$this->mongo_db->order_by($shortField);				
		if($num_page):				
			$this->mongo_db->limit($num_page);
			$this->mongo_db->offset($cnt);						
		endif;
		if($action == 'count'):	
			return $this->mongo_db->count($tbl_name);
		elseif($action == 'single'):	
			$result = $this->mongo_db->find_one($tbl_name);
			if($result):
				return json_decode(json_encode($result),true);
			else:
				return false;
			endif;
		elseif($action == 'multiple'):	
			$result = $this->mongo_db->get($tbl_name);
			if($result):	
				return json_decode(json_encode($result),true);
			else:		
				return false;
			endif;
		else:
			return false;
		endif;
	}	// END OF FUNCTION

	/***********************************************************************
	** Function name: getMultipleDataByParticularField
	** Developed By: Ashish
	** Purpose: This function used for getMultipleDataByParticularField
	** Date : 23 JUNE 2022
	************************************************************************/
	public function getMultipleDataByParticularField($tableName='',$fieldName='',$fieldValue='')
	{  
		$this->db->select('*');
		$this->db->from($tableName);
		if(isset($fieldName) && isset($fieldValue)):
			$this->db->where($fieldName,$fieldValue);
		endif;
		$query = $this->db->get();
		if($query->num_rows() > 0):
			return $query->result_array();
		else:
			return false;
		endif;
	}	// END OF FUNCTION

	/***********************************************************************
	** Function name : delete_image_by_image_name
	** Developed By : Ashish UMrao
	** Purpose  : This function used for delete image by image name
	** Date : 23 JUNE 2022
	************************************************************************/
	function delete_image_by_image_name($tableName='',$fieldName='',$fieldValue='')
	{	
		$this->db->delete($tableName,array($fieldName=>$fieldValue));
		return true;
	}

	/***********************************************************************
	** Function name: getDataByQuery
	** Developed By: Manoj Kumar
	** Purpose: This function used for get data by query
	** Date : 23 JUNE 2022
	************************************************************************/
	public function getDataByQuery($action='',$query='',$from='')
	{  
		$query = $this->db->query($query);
		if($from == 'procedure'):
			mysqli_next_result( $this->db->conn_id);
		endif;
		if($action == 'count'):	
			return $query->num_rows();
		elseif($action == 'single'):	
			if($query->num_rows() > 0):
				return $query->row_array();
			else:
				return false;
			endif;
		elseif($action == 'multiple'):	
			if($query->num_rows() > 0):
				return $query->result_array();
			else:
				return false;
			endif;
		else:
			return false;
		endif;
	}	// END OF FUNCTION

	/***********************************************************************
	** Function name 	: getParticularFieldData
	** Developed By 	: Afsar Ali
	** Purpose 			: This function used for get particular fields data
	** Date 			: 28 JUNE 2022
	************************************************************************/
	public function getParticularFieldData($action='',$fileds='',$tbl_name='',$wcon='',$shortField='',$num_page='',$cnt='')
	{  
		if(empty($fileds)){$this->db->select('ftable.*');}else{$this->db->select($fileds);}
		$this->db->from($tbl_name);
		if($wcon['where']):		$this->db->where($wcon['where']);	 		endif;
		if($wcon['like']):  	$this->db->where($wcon['like']); 			endif;
		if($shortField):		$this->db->order_by($shortField);			endif;
		if($num_page):			$this->db->limit($num_page,$cnt);			endif;
		$query = $this->db->get();
		if($action == 'count'):	
			return $query->num_rows();
		elseif($action == 'single'):	
			if($query->num_rows() > 0):
				return $query->row_array();
			else:
				return false;
			endif;
		elseif($action == 'multiple'):	
			if($query->num_rows() > 0):
				return $query->result_array();
			else:
				return false;
			endif;
		else:
			return false;
		endif;

	}	// END OF FUNCTION

	public function getTaskQuestions($id, $qname){  
	
		$this->db->select('*');

		$this->db->from('questions');
		if($qname != ''){
			//SELECT * FROM `bl_questions` WHERE `ques_name` LIKE '%Mountains, plateaus, and plains%'

			$where = "ques_name LIKE '%".$qname."%' ";
			$this->db->where($where);
		}
    	$this->db->where('task_id',$id);
		$query = $this->db->get();
      //print_r($query);die;
		if($query->num_rows() > 0):
			return $query->result_array();
		else:
			return false;
		endif;
	}

	public function get_taskid($editId){  
	
		$this->db->select('task_id');

		$this->db->from('questions');
    	$this->db->where('id',$editId);
		$query = $this->db->get();
      //print_r($query);die;
		if($query->num_rows() > 0):
			return $query->row();
		else:
			return false;
		endif;
	}

	/***********************************************************************
	** Function name 	: get_taskData
	** Developed By 	: Afsar Ali
	** Purpose 			: This function used for get particular task id data
	** Date 			: 28 JUNE 2022
	************************************************************************/
	public function get_taskData($changeStatusId){  
	
		$this->db->select('*');

		$this->db->from('task');
    	$this->db->where('id',$changeStatusId);
		$query = $this->db->get();
      //print_r($query);die;
		if($query->num_rows() > 0):
			return $query->row();
		else:
			return false;
		endif;
	}
	function answerlist($userId){
		$this->db->select('ans.task_id, task.task_name, ans.task_attempt_date, ans.user_id');
		$this->db->from('task as task');
		$this->db->join('task_attempt_answers as ans','task.id = ans.task_id');
    	$this->db->where('user_id', $userId);
		$this->db->group_by('task_id');
		$query = $this->db->get();
		if($query->num_rows() > 0):
			return $query->result_array();
		else:
			return false;
		endif;
	}

	/***********************************************************************
	** Function name 	: get_Questions
	** Developed By 	: Afsar Ali
	** Purpose 			: This function used for get Questions
	** Date 			: 28 JUNE 2022
	************************************************************************/
	public function getQuestions($taskId){  
	
		$this->db->select('*');

		$this->db->from('task_attempt_answers');
    	$this->db->where('task_id',$taskId);
		$query = $this->db->get();
      //print_r($query);die;
		if($query->num_rows() > 0):
			return $query->result_array();
		else:
			return false;
		endif;
	}

	function change_pass($session_id,$new_pass)
	{
	$data = array( 
       'password' => md5($new_pass),
      
    );
$this->db->where('id', $session_id);
$this->db->update('users', $data);

	}

	function answerlistgenratepdf($userId, $taskId){
		$this->db->select('ans.*');
		$this->db->from('task as task');
		$this->db->join('task_attempt_answers as ans','task.id = ans.task_id');
    	$this->db->where('user_id', $userId);
		$this->db->where('task_id', $taskId);
		$query = $this->db->get();
		if($query->num_rows() > 0):
			return $query->result_array();
		else:
			return false;
		endif;
	}

	/***********************************************************************
	** Function name 	: getExam
	** Developed By 	: Ritu Mishra
	** Purpose 			: This function used for get Exam Classes
	** Date 			: 28 JUNE 2022
	************************************************************************/
	function getExam(){
		$this->db->select('*');
		$this->db->from('classes');
		$this->db->where('status','A');
		$query = $this->db->get();
		if($query->num_rows() > 0):
			return $query->result();
		else:
			return false;
		endif;
	}

	/***********************************************************************
	** Function name 	: gettaskdata
	** Developed By 	: Ritu Mishra
	** Purpose 			: This function used for get  Task by Perticular Id
	** Date 			: 21 OCT 2022
	************************************************************************/
	function gettaskdata($taskId){
		$this->db->select('*');
		$this->db->from('task');
		$this->db->where('id', $taskId);
		$query = $this->db->get();
		if($query->num_rows() > 0):
			return $query->row();
		else:
			return false;
		endif;
	}

	public function getDataQuestions1($action='',$tbl_name='',$wcon='',$shortField='',$num_page='',$cnt='')
	{  $this->db->select('*');
		$this->db->from($tbl_name);
		if($wcon['where']):		$this->db->where($wcon['where']);	 		endif;
		if($wcon['like']):  	$this->db->where($wcon['like']); 			endif;
		if($shortField):		$this->db->order_by($shortField);			endif;
		if($num_page):			$this->db->limit($num_page,$cnt);			endif;
		//$this->db->where('task_id',$id);
		$query = $this->db->get();
		
		return $query->result_array();
			

	}

	public function getDataAttempted($action='',$tbl_name='',$wcon='',$shortField='',$num_page='',$cnt='', $taskkkkk_id='')
	{  
		$this->db->select('ftable.*');
		$this->db->from($tbl_name);
		if($wcon['where']):		$this->db->where($wcon['where']);	 		endif;
		if($wcon['like']):  	$this->db->where($wcon['like']); 			endif;
		if($shortField):		$this->db->order_by($shortField);			endif;
		if($num_page):			$this->db->limit($num_page,$cnt);			endif;
		if($taskkkkk_id):  	$this->db->where('task_id', $taskkkkk_id); 		endif;
		$this->db->group_by('user_id');
		$query = $this->db->get();
		if($action == 'count'):	
			return $query->num_rows();
		elseif($action == 'single'):	
			if($query->num_rows() > 0):
				return $query->row_array();
			else:
				return false;
			endif;
		elseif($action == 'multiple'):	
			if($query->num_rows() > 0):
				return $query->result_array();
			else:
				return false;
			endif;
		else:
			return false;
		endif;

	}	// END OF FUNCTION

		/***********************************************************************
	** Function name 	: get_skip_answer
	** Developed By 	: Ritu mishra
	** Purpose 			: This function used for get particular task id 
	** Date 			: 20 Nov 2022
	************************************************************************/
	public function get_skip_answer($taskId,$userId){  
	
		$this->db->select('answer');

		$this->db->from('task_attempt_answers');
    	$this->db->where('task_id',$taskId);
		$this->db->where('user_id',$userId);
		$this->db->where('answer','');
		$query = $this->db->get();
      //print_r($query);die;
		if($query->result() > 0):
			return $query->result();
		else:
			return false;
		endif;
	}

	/***********************************************************************
	** Function name 	: get_attempt_answer
	** Developed By 	: Ritu Mishra
	** Purpose 			: This function used for attempt answer
	** Date 			: 20 Nov 2022
	************************************************************************/
	public function get_attempt_answer($taskId,$userId){  
	
		$this->db->select('id');

		$this->db->from('task_attempt_answers');
    	$this->db->where('task_id',$taskId);
		$this->db->where('user_id',$userId);
		$this->db->where('answer!=','');
		$query = $this->db->get();
      //print_r($query);die;
		if($query->num_rows() > 0):
			return $query->result();
		else:
			return false;
		endif;
	}
	/***********************************************************************
	** Function name 	: get_wrong_answer
	** Developed By 	: Ritu Mishra
	** Purpose 			: This function used for get Wrong answer
	** Date 			: 20 Nov 2022
	************************************************************************/
	public function get_wrong_answer($taskId,$userId){  
	
		$this->db->select('answer');

		$this->db->from('task_attempt_answers');
    	$this->db->where('task_id',$taskId);
		$this->db->where('user_id',$userId);
		$this->db->where('answer','no');
		$query = $this->db->get();
      //print_r($query);die;
		if($query->num_rows() > 0):
			return $query->result();
		else:
			return false;
		endif;
	}
}	